<?php

namespace Supportingcast;

use Exception;

class ScApiBase {

	protected $api_base;

	protected $api;
	protected $data = null;

	public function __construct() {
		$this->api = new Api();
	}


	public function getAll() {
		$this->apiGet($this->api_base . '?max_page_size=500');
	}

	public function getId(int $id) {
		$this->apiGet($this->api_base . '/' . $id);
	}

	public function create(array $jsonData) {
		$this->apiPost($this->api_base . '/', $jsonData);
	}

	public function updateId(int $id, array $jsonData) {
		$this->apiPut($this->api_base . '/' . $id, $jsonData);
	}


	/**
	 * Private API function calls
	 */
	protected function apiGet(string $path)
	{
		$this->api->get($path);
		$this->apiProcess();
	}

	protected function apiPost(string $path, array $jsonData)
	{
		$this->api->post($path, $jsonData);
		$this->apiProcess();
	}

	protected function apiPut(string $path, array $jsonData)
	{
		$this->api->put($path, $jsonData);
		$this->apiProcess();
	}

	private function apiProcess()
	{
		if ($this->api->success()) {
			$this->data = $this->api->getBody();
			return;
		}
		throw new Exception($this->api->getErrorMsg());
	}

	/**
	 * Magic Methods
	 */
	public function __get($property)
	{
		if (isset($this->data->$property)) {
			return $this->data->$property;
		}
		return $this->$property;
	}

}